unit ObimpAX_TLB;

// ************************************************************************ //
// WARNING
// -------
// The types declared in this file were generated from data read from a
// Type Library. If this type library is explicitly or indirectly (via
// another type library referring to this type library) re-imported, or the
// 'Refresh' command of the Type Library Editor activated while editing the
// Type Library, the contents of this file will be regenerated and all
// manual modifications will be lost.
// ************************************************************************ //

// $Rev: 34747 $
// File generated on 27.04.2013 20:05:14 from Type Library described below.

// ************************************************************************  //
// Type Lib: D:\OBIMP\ObimpIM\OBIMP\ObimpAX\obimp_ax (1)
// LIBID: {D9081A9E-79FF-4C00-A5E8-F3C0F15B05E1}
// LCID: 0
// Helpfile:
// HelpString:
// DepndLst:
//   (1) v2.0 stdole, (C:\WINDOWS\system32\stdole2.tlb)
// ************************************************************************ //
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers.
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
{$ALIGN 4}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:
//   Type Libraries     : LIBID_xxxx
//   CoClasses          : CLASS_xxxx
//   DISPInterfaces     : DIID_xxxx
//   Non-DISP interfaces: IID_xxxx
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  ObimpAXMajorVersion = 1;
  ObimpAXMinorVersion = 0;

  LIBID_ObimpAX: TGUID = '{D9081A9E-79FF-4C00-A5E8-F3C0F15B05E1}';

  IID_IObimpProto: TGUID = '{67CE4963-B647-4A7A-B5D5-ADA99E4A678B}';
  DIID_IObimpProtoEvents: TGUID = '{0332B779-B89A-4D60-82E2-2A1CBDA0EC6D}';
  CLASS_ObimpProto: TGUID = '{0E115E20-57AF-4D7C-9D68-505C47668238}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary
// *********************************************************************//
  IObimpProto = interface;
  IObimpProtoDisp = dispinterface;
  IObimpProtoEvents = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library
// (NOTE: Here we map each CoClass to its Default Interface)
// *********************************************************************//
  ObimpProto = IObimpProto;


// *********************************************************************//
// Declaration of structures, unions and aliases.
// *********************************************************************//
  TRcvdMsgInfo = record
    Account: WideString;
    MsgUniqID: SYSUINT;
    MsgType: SYSUINT;
    MsgText: WideString;
    AckRequired: WordBool;
    IsOfflineMsg: WordBool;
    OfflineDT: Int64;
    IsSystemMsg: WordBool;
    SysMsgPos: Byte;
    TranspID: SYSUINT;
  end;

  TMsgAck = record
    Account: WideString;
    MsgUniqID: SYSUINT;
    TranspID: SYSUINT;
  end;

  TRcvdAuthReq = record
    Account: WideString;
    ReasonText: WideString;
    IsOfflineMsg: WordBool;
    OfflineDT: Int64;
    TranspID: SYSUINT;
  end;

  TRcvdAuthReply = record
    Account: WideString;
    ReplyCode: Word;
    IsOfflineMsg: WordBool;
    OfflineDT: Int64;
    TranspID: SYSUINT;
  end;

  TRcvdAuthRevoke = record
    Account: WideString;
    ReasonText: WideString;
    IsOfflineMsg: WordBool;
    OfflineDT: Int64;
    TranspID: SYSUINT;
  end;

  TLoginInfo = record
    Host: WideString;
    Port: SYSUINT;
    Account: WideString;
    Password: WideString;
  end;

  TStatusInfo = record
    Status: SYSUINT;
    StatusName: WideString;
  end;

  TClientInfo = record
    ClientName: WideString;
    ClientVerMaj: Word;
    ClientVerMin: Word;
    ClientVerRel: Word;
    ClientVerBuild: Word;
    ClientType: Word;
    ClientLang: Word;
  end;

  TSendMsgInfo = record
    Account: WideString;
    MsgUniqID: SYSUINT;
    MsgText: WideString;
    AckRequired: WordBool;
    TranspID: SYSUINT;
  end;

  TSendAuthReq = record
    Account: WideString;
    ReasonText: WideString;
    TranspID: SYSUINT;
  end;

  TSendAuthReply = record
    Account: WideString;
    ReplyCode: Word;
    TranspID: SYSUINT;
  end;

  TSendAuthRevoke = record
    Account: WideString;
    ReasonText: WideString;
    TranspID: SYSUINT;
  end;


// *********************************************************************//
// Interface: IObimpProto
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {67CE4963-B647-4A7A-B5D5-ADA99E4A678B}
// *********************************************************************//
  IObimpProto = interface(IDispatch)
    ['{67CE4963-B647-4A7A-B5D5-ADA99E4A678B}']
    function GetProtoIntfVer: SYSUINT; stdcall;
    function Login(LoginInfo: TLoginInfo; ClientInfo: TClientInfo; StatusInfo: TStatusInfo): SYSINT; stdcall;
    function Logoff: SYSINT; stdcall;
    function ChangeStatus(StatusInfo: TStatusInfo): SYSINT; stdcall;
    function SendMsg(SendMsgInfo: TSendMsgInfo): SYSINT; stdcall;
    function SendMsgAck(MsgAck: TMsgAck): SYSINT; stdcall;
    function SendAuthReq(AuthReq: TSendAuthReq): SYSINT; stdcall;
    function SendAuthReply(AuthReply: TSendAuthReply): SYSINT; stdcall;
    function SendAuthRevoke(AuthRevoke: TSendAuthRevoke): SYSINT; stdcall;
  end;

// *********************************************************************//
// DispIntf:  IObimpProtoDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {67CE4963-B647-4A7A-B5D5-ADA99E4A678B}
// *********************************************************************//
  IObimpProtoDisp = dispinterface
    ['{67CE4963-B647-4A7A-B5D5-ADA99E4A678B}']
    function GetProtoIntfVer: SYSUINT; dispid 201;
    function Login(LoginInfo: {??TLoginInfo}OleVariant; ClientInfo: {??TClientInfo}OleVariant;
                   StatusInfo: {??TStatusInfo}OleVariant): SYSINT; dispid 202;
    function Logoff: SYSINT; dispid 203;
    function ChangeStatus(StatusInfo: {??TStatusInfo}OleVariant): SYSINT; dispid 204;
    function SendMsg(SendMsgInfo: {??TSendMsgInfo}OleVariant): SYSINT; dispid 205;
    function SendMsgAck(MsgAck: {??TMsgAck}OleVariant): SYSINT; dispid 206;
    function SendAuthReq(AuthReq: {??TSendAuthReq}OleVariant): SYSINT; dispid 207;
    function SendAuthReply(AuthReply: {??TSendAuthReply}OleVariant): SYSINT; dispid 208;
    function SendAuthRevoke(AuthRevoke: {??TSendAuthRevoke}OleVariant): SYSINT; dispid 209;
  end;

// *********************************************************************//
// DispIntf:  IObimpProtoEvents
// Flags:     (0)
// GUID:      {0332B779-B89A-4D60-82E2-2A1CBDA0EC6D}
// *********************************************************************//
  IObimpProtoEvents = dispinterface
    ['{0332B779-B89A-4D60-82E2-2A1CBDA0EC6D}']
    function GetProtoIntfVer: SYSUINT; dispid 201;
    procedure ConnectionFailed; dispid 202;
    procedure LoginSuccess; dispid 203;
    procedure LoginFailed(LoginFailedCode: {??Word}OleVariant); dispid 204;
    procedure ServerBye(ByeReasonCode: {??Word}OleVariant); dispid 205;
    procedure MsgReceived(RcvdMsgInfo: {??TRcvdMsgInfo}OleVariant); dispid 206;
    procedure MsgAckRcvd(MsgAck: {??TMsgAck}OleVariant); dispid 207;
    procedure AuthReqRcvd(AuthReq: {??TRcvdAuthReq}OleVariant); dispid 208;
    procedure AuthReplyRcvd(AuthReply: {??TRcvdAuthReply}OleVariant); dispid 209;
    procedure AuthRevokeRcvd(AuthRevoke: {??TRcvdAuthRevoke}OleVariant); dispid 210;
  end;

// *********************************************************************//
// The Class CoObimpProto provides a Create and CreateRemote method to
// create instances of the default interface IObimpProto exposed by
// the CoClass ObimpProto. The functions are intended to be used by
// clients wishing to automate the CoClass objects exposed by the
// server of this typelibrary.
// *********************************************************************//
  CoObimpProto = class
    class function Create: IObimpProto;
    class function CreateRemote(const MachineName: string): IObimpProto;
  end;

implementation

uses ComObj;

class function CoObimpProto.Create: IObimpProto;
begin
  Result := CreateComObject(CLASS_ObimpProto) as IObimpProto;
end;

class function CoObimpProto.CreateRemote(const MachineName: string): IObimpProto;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_ObimpProto) as IObimpProto;
end;

end.

